var PHConfig = {
    _timer: null,
    connectTimeoutInterval: 8000, // ms
    clearTimer: function(){
        if (PHConfig._timer) { window.clearTimeout(PHConfig._timer); }
        PHConfig._timer = null;
    }
};

function PHInit(authObj) {
    // entry point for all pages
    PHConfig.clearTimer();
    __init(authObj);
}

function PHRefresh(authObj, context) {
    PHConfig.clearTimer();
    if (typeof(__refresh) === 'function') {
        __refresh(authObj, context);
    }
}
function stopSpinAndReveal() {
    document.location.href = 'pheed://stop-spin-and-reveal';
}

String.prototype.parseMentionsTags = function(){
    if (this == '') return this;
    var str = this.replace(/(^|\s)(@([\w\.\-]+))\b/g, '$1<span class="mention">@<a href="pheed://channel-url/$3">$3</a></span>');
    return str.replace(/(^|\s)(#([\w\.\-]+))\b/g, '$1<span class="tag">#<a href="pheed://tag/$3">$3</a></span>');
};

String.prototype.profileLink = function() {
    if (this == '') return this;
    var profilePath = this.match(/\/([\w_.])+$/g);
    if (profilePath) { profilePath = profilePath[0].substr(1); } else { return this; }
    return 'pheed://channel' + profilePath;
};

Date.prototype.monthNames = [
    "January", "February", "March",
    "April", "May", "June",
    "July", "August", "September",
    "October", "November", "December"
];

Date.prototype.getMonthName = function() {
    return this.monthNames[this.getMonth()];
};

Date.prototype.getShortMonthName = function () {
    return this.getMonthName().substr(0, 3);
};


$.fn.dateFormat = function(date, date2, format, options) {
    function zeroPad(n) {
        return (n < 10 ? '0' : '') + n;
    }

    var dateFormatters = {
        s	: function(d)	{ return d.getSeconds() },
        ss	: function(d)	{ return zeroPad(d.getSeconds()) },
        m	: function(d)	{ return d.getMinutes() },
        mm	: function(d)	{ return zeroPad(d.getMinutes()) },
        h	: function(d)	{ return d.getHours() % 12 || 12 },
        hh	: function(d)	{ return zeroPad(d.getHours() % 12 || 12) },
        H	: function(d)	{ return d.getHours() },
        HH	: function(d)	{ return zeroPad(d.getHours()) },
        d	: function(d)	{ return d.getDate() },
        dd	: function(d)	{ return zeroPad(d.getDate()) },
        ddd	: function(d,o)	{ return d.getShortDayName() },
        dddd: function(d,o)	{ return d.getDayName() },
        M	: function(d)	{ return d.getMonth() + 1 },
        MM	: function(d)	{ return zeroPad(d.getMonth() + 1) },
        MMM	: function(d,o)	{ return d.getShortMonthName() },
        MMMM: function(d,o)	{ return d.getMonthName() },
        yy	: function(d)	{ return (d.getFullYear()+'').substring(2) },
        yyyy: function(d)	{ return d.getFullYear() },
        t	: function(d)	{ return d.getHours() < 12 ? 'a' : 'p' },
        tt	: function(d)	{ return d.getHours() < 12 ? 'am' : 'pm' },
        T	: function(d)	{ return d.getHours() < 12 ? 'A' : 'P' },
        TT	: function(d)	{ return d.getHours() < 12 ? 'AM' : 'PM' },
        u	: function(d)	{ return formatDate(d, "yyyy-MM-dd'T'HH:mm:ss'Z'") },
        S	: function(d)	{
            var date = d.getDate();
            if (date > 10 && date < 20) {
                return 'th';
            }
            return ['st', 'nd', 'rd'][date%10-1] || 'th';
        }
    };

    function formatDate(date, format, options) {
        return formatDates(date, null, format, options);
    }

    function formatDates(date1, date2, format, options) {
        options = options || {};
        var date = date1,
            otherDate = date2,
            i, len = format.length, c,
            i2, formatter,
            res = '';
        for (i=0; i<len; i++) {
            c = format.charAt(i);
            if (c == "'") {
                for (i2=i+1; i2<len; i2++) {
                    if (format.charAt(i2) == "'") {
                        if (date) {
                            if (i2 == i+1) {
                                res += "'";
                            }else{
                                res += format.substring(i+1, i2);
                            }
                            i = i2;
                        }
                        break;
                    }
                }
            }
            else if (c == '(') {
                for (i2=i+1; i2<len; i2++) {
                    if (format.charAt(i2) == ')') {
                        var subres = formatDate(date, format.substring(i+1, i2), options);
                        if (parseInt(subres.replace(/\D/, ''), 10)) {
                            res += subres;
                        }
                        i = i2;
                        break;
                    }
                }
            }
            else if (c == '[') {
                for (i2=i+1; i2<len; i2++) {
                    if (format.charAt(i2) == ']') {
                        var subformat = format.substring(i+1, i2);
                        var subres = formatDate(date, subformat, options);
                        if (subres != formatDate(otherDate, subformat, options)) {
                            res += subres;
                        }
                        i = i2;
                        break;
                    }
                }
            }
            else if (c == '{') {
                date = date2;
                otherDate = date1;
            }
            else if (c == '}') {
                date = date1;
                otherDate = date2;
            }
            else {
                for (i2=len; i2>i; i2--) {
                    if (formatter = dateFormatters[format.substring(i, i2)]) {
                        if (date) {
                            res += formatter(date, options);
                        }
                        i = i2 - 1;
                        break;
                    }
                }
                if (i2 == i) {
                    if (date) {
                        res += c;
                    }
                }
            }
        }
        return res;
    }

    if (arguments.length === 3) {
        return formatDates(date, null, date2, options);
    } else {
        return formatDates(date, date2, format, options);
    }
};


Date.prototype.formatDate = function(format, options) {
    return $().dateFormat(this, format, options || {});
};


Date.prototype.prettyDate = function(compareTo, th) {
    if (th){
        //don't show dates before Jul, 1st 2012
        if (this.getTime() < 1341090000000) return '';
    }

    function normalize(val, single) {
        var margin = 0.1;
        if (val >= single && val <= single * (1 + margin)) {
            return single;
        }
        return val;
    }

    compareTo = compareTo || new Date();

    var lang = {
            ago: 'ago',
            now: 'Just Now',
            minute: 'minute',
            minutes: 'minutes',
            hour: 'hour',
            hours: 'hours',
            day: 'day',
            days: 'days',
            week: 'week',
            weeks: 'weeks',
            month: 'month',
            months: 'months',
            year: 'year',
            years: 'years'
        },
        formats = [
            [60, lang.now],
            [3600, lang.minute, lang.minutes, 60],
            // 60 minutes, 1 minute
            [86400, lang.hour, lang.hours, 3600],
            // 24 hours, 1 hour
            [604800, lang.day, lang.days, 86400],
            // 7 days, 1 day
            [2628000, lang.week, lang.weeks, 604800],
            // ~1 month, 1 week
            [31536000, lang.month, lang.months, 2628000],
            // 1 year, ~1 month
            [Infinity, lang.year, lang.years, 31536000] // Infinity, 1 year
        ],
        token,
        seconds = (compareTo - this + (compareTo.getTimezoneOffset() - this.getTimezoneOffset()) * 60000) / 1000;

    if (seconds < 0) {
        seconds = Math.abs(seconds);
        token = '';
    } else {
        token = ' ' + lang.ago;
    }

    if (seconds > formats[2][0]) {
        if (this.getFullYear() != compareTo.getFullYear()) {
            return '' + this.formatDate('MMM d, yyyy');
        } else {
            return '' + this.formatDate('MMM d');
        }
    }

    for (var i = 0, format = formats[0]; formats[i]; format = formats[++i]) {
        if (seconds < format[0]) {
            if (i === 0) {
                // Now
                return format[1];
            }

            var val = Math.ceil(normalize(seconds, format[3]) / (format[3]));
            return val +
                ' ' +
                (val != 1 ? format[2] : format[1]) +
                (i > 0 ? token : '');
        }
    }
};

function PHNativeCmd(data, interval){
    interval = interval || 10;
    window.setTimeout(function() { window.location.href = 'pheed://' + data;}, interval);
}

$(function() {
    $(document).on('touchmove', function(e) {
        var target = $(e.target);
        if (target.hasClass('tm-ignore')) { e.preventDefault(); return; }
        if (target.closest('.ui-slider-mini').length) {
            e.preventDefault();
            target.addClass('tm-ignore');
        }
    });
});