var PMAnimation = {
    _win: $(window),
    _doc: $(document),
    _checkPoint: 0,
    stop: false,
    ignore: false,

    init: function(bottomCallback) {
        if (!window.cancelAnimationFrame)
            window.cancelAnimationFrame = function(id) {
                clearTimeout(id);
            };

        window.requestAnimFrame = (function () {
            return  window.requestAnimationFrame ||
                window.webkitRequestAnimationFrame ||
                window.mozRequestAnimationFrame ||
                window.oRequestAnimationFrame ||
                window.msRequestAnimationFrame ||
                function (callback) {
                    window.setTimeout(callback, 1000 / 60);
                };
        })();

        var update = function() {
            if (PMAnimation.ignore) {return;}
            var scrollTop = PMAnimation._win.scrollTop(),
                docHeight = PMAnimation._doc.height(),
                winHeight = PMAnimation._win.height(),
                diff = (docHeight - winHeight);

            if (diff && scrollTop >= diff) {
                PMAnimation._checkPoint = scrollTop;
                if (bottomCallback) { bottomCallback(); }
            }
        };

        (function animloop() {
            if (!PMAnimation.stop) {
                requestAnimFrame(animloop);
                update();
            }
        })();
    }
};
